/* InstructionMemory.java
 * Created 9/12/96 by Mark Gritter 
 */

package EDU.gac.mgritter.SLIME;

import java.lang.*;
import java.util.*;

/**
 * Instruction memory consists of a vector of instructions.
 */
public class InstructionMemory {
  private Vector mem;
  
  /**
   * Create a new memory.
   */
  public InstructionMemory() {
    mem = new Vector();
  }

  /**
   * Get an instruction from memory. 
   */
  public Instruction get(int location) throws ArrayIndexOutOfBoundsException {
    return (Instruction)mem.elementAt(location);
  }

  /**
   * Set an instruction in memeory.  Fill any gaps with null Instructions.
   */
  public void set(int location, Instruction i) {
    int size = mem.size();
    mem.ensureCapacity(location + 1);
    while (location >= size) {
      mem.addElement(null);
      size++;
    }
    try {
      mem.setElementAt(i, location);
    }
    catch (ArrayIndexOutOfBoundsException e) {
      System.err.println("InstructionMemory.put: " + e);
    }
  }

  /**
   * Size of instruction memory.
   */
  public int size() {
    return mem.size();
  }
}


