/* JumpInstruction.java
 * Created 9/13/96 by Mark Gritter 
 */

package EDU.gac.mgritter.SLIME;

import java.lang.*;

/**
 * A jump instruction has only a destination register.
 */
public class JumpInstruction extends Instruction {
  protected int addr;

  private int op;
  public static final int J = 1;
  
  /**
   * Create a new instruction.
   *
   * @param operation Should be J, the jump instruction
   * @param address Destination register for jump.
   */
  public JumpInstruction(int operation, int address) {
    op = operation;
    addr = address;
  }
  
  public int getAddress() { return addr; }

  public String mnemonic() {
    switch (op) {
    case J: return "j";
    }
    return "JMP?";
  }

  public String arguments() {
    return "[" + formatReg(addr) + "]";
  }

  public void perform(MachineState state) {
    switch (op) {
    case J:
      state.jump(state.getRegister(addr));
      break;
    }
  }
}


