/* SLIME.java
 * Created 9/12/96 by Mark Gritter 
 *
 * Version 0.3 - Modified 6/3/97 by Mark Gritter
 *   Added "version" to Main class.
 *             - Modified 7/28/97 by Mark Gritter
 *   Removed old info about "GraphicPath" stuff
 *   Added Applet code and getProgram function.
 *
 * Version 0.4 - Modified 7/31/97 by Max Hailperin <max@gac.edu>
 *   Upped version to 0.4
 */

package EDU.gac.mgritter.SLIME;

import java.awt.*;
import java.applet.Applet;

/**
 * SLIME should be executed with a command line somthing 
 * like this:
 *
 * java -EDU.gac.mgritter.SLIME.SLIME [myfile.spim]
 */

public class SLIME extends Applet {
  public static final String version = "0.4";

  private static SLIME appletObject = null;
  public static SLIME getApplet() {
    return appletObject;
  }

  private static boolean appletFlag = false;
  public static boolean isApplet() {
    return appletFlag;
  }
  
  private MachineThread thread;
  private MachineState state;
  private TextArea inputText;
  private Indicator stopped;

  public SLIME() {
    appletFlag = true;
    appletObject = this;
    thread = new MachineThread();
    state = thread.getState();
  }

  public void init() {
    inputText = new TextArea(80,24);
    Font courier = new Font("Courier", Font.PLAIN, 10);
    if (courier != null) inputText.setFont(courier);
    setLayout(new BorderLayout());
    add("Center", inputText);
    Panel p = new Panel();
    p.setLayout(new BorderLayout());
    p.add("Center", new Label("SLIME " + version + " applet", Label.CENTER));
    stopped = new Indicator("Run","Running","Stopped");
    p.add("West", stopped);
    add("North", p);
    add("South", new Label("Enter program code in this text area, then press \"Load\"."));
    state.setPC(0);
    thread.start();
  }

  public void destroy() {
    thread.stopMachine();
  }

  public String getProgram() {
    return inputText.getText() + "\n";
  }

  public void quit() {
    thread.stopMachine();
    stopped.setState(true);
  }

  public boolean action(Event e, Object o) {
    if (e.target instanceof Indicator) {
      if (o.equals("Run") && stopped.state()) {
	stopped.setState(false);
	thread = new MachineThread();
	state = thread.getState();
	thread.start();
	return true;
      }
    }
    return false;
  }

  public static void main(String[] args) {
    // Notice that no SLIME object gets created here.
    appletFlag = false;
    MachineThread thread = new MachineThread();
    MachineState state = thread.getState();
    if (args.length > 0) {
      state.loadFromFile(args[0]);
    }
    state.setPC(0);
    thread.run();
  }
}





