/* SpecialInstruction.java
 * Created 9/13/96 by Mark Gritter 
 */

package EDU.gac.mgritter.SLIME;

import java.lang.*;

/**
 * A special instruction has no arguments.
 */
public class SpecialInstruction extends Instruction {

  private int op;
  public static final int STOP = 1;
  public static final int SYSCALL = 2;
  
  /**
   * Create a new instruction.
   *
   * @param operation One of STOP or SYSCALL.
   */
  public SpecialInstruction(int operation) {
    op = operation;
  }
  
  public String mnemonic() {
    switch (op) {
    case STOP: return "halt";
    case SYSCALL: return "syscall";
    }
    return "SPC?";
  }

  public String arguments() {
    return "";
  }

  public void perform(MachineState state) {
    switch (op) {
    case STOP:
      state.raiseException(MachineState.EX_STOP);
      break;
    }
  }
}
